/*

  Copyright (C) 2007, Yusuke Sakumoto.
  All rights reserved.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef __COMMON
#define __COMMON

#define __DEBUG 0
#define __TIMEOUT 1
#define __ADAPT 1
#include <iostream>
#include <list>
#include <cassert>

#define INF 1e16

class AvgData
{
  double time;
  double sum;
  const double st;
public:
  AvgData (const double st_ = 0.0):time (st_), sum (0.0), st (st_)
  {
  };
  double get_avg ()
  {
    if (st == time)
      return 0.0;
    return sum / (time - st);
  }

  void update_avg (const double time_, const double data_)
  {
    sum += data_ * (time_ - time);
    time = time_;
  }
};
#endif
