/*

  Copyright (C) 2007, Yusuke Sakumoto.
  All rights reserved.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "fSimOutput.h"

FSimOutput::FSimOutput (const char *output_file, const bool print_flag_dyna_, const bool print_flag_avg_, const bool print_flag_trace_all_, const bool print_flag_namtrace_all_):print_flag_dyna (print_flag_dyna_), print_flag_avg (print_flag_avg_),
print_flag_trace_all (print_flag_trace_all_),
print_flag_namtrace_all (print_flag_namtrace_all_)
{
  try
  {
    output.open (output_file);
  } catch (std::ofstream::failure e)
  {
    std::cerr << "Cannot open file : " << output_file << std::endl;
    std::exit (1);
  }
}

FSimOutput::~FSimOutput ()
{
  output.close ();
}

void
FSimOutput::output_f (std::string str)
{
  output << str;
}
