/*

  Copyright (C) 2007, Yusuke Sakumoto.
  All rights reserved.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef __FSimOutput
#define __FSimOutput

#include "common.h"
#include <fstream>
#include <string>

class FSimOutput
{
  std::ofstream output;
  bool print_flag_dyna, print_flag_avg, print_flag_trace_all,
    print_flag_namtrace_all;

public:
    FSimOutput (const char *output_file, const bool print_flag_dyna_,
		const bool print_flag_avg_, const bool print_flag_trace_all_,
		const bool print_flag_namtrace_all_);
   ~FSimOutput ();

  bool get_print_flag_dyna ()
  {
    return print_flag_dyna;
  }
  bool get_print_flag_avg ()
  {
    return print_flag_avg;
  }
  bool get_print_flag_trace_all ()
  {
    return print_flag_trace_all;
  }
  bool get_print_flag_namtrace_all ()
  {
    return print_flag_namtrace_all;
  }

  void output_f (std::string str);
  void flush ()
  {
    output.flush ();
  }
};

#endif
