/*

  Copyright (C) 2007, Yusuke Sakumoto.
  All rights reserved.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef __ListState
#define __ListState

#include "common.h"

typedef struct
{
  double time;
  double data;
} State;

typedef struct snode
{
  State state;
  struct snode *next;
} SNode;

class ListState
{
  SNode *head;
  SNode *tail;
  double maxStateTime;
  double timeout_time;
public:
    ListState ():head (NULL), tail (NULL), maxStateTime (0.0),
    timeout_time (0.0)
  {
  }
  void set_timeout (double timeout_time_)
  {
    timeout_time = timeout_time_;
  }
  void push_back (double time, double data);
  void pop_front ();
  void put_state (double time, double data);
  double get_state (double time);
  void test ();
  std::string print ();
};

#endif
